import RPi.GPIO as GPIO
import subprocess
import time
import os

GPIO.setmode(GPIO.BCM)
GPIO.setup(21, GPIO.IN, pull_up_down=GPIO.PUD_UP) # button #1
GPIO.setup(20, GPIO.IN, pull_up_down=GPIO.PUD_UP) # button #2
GPIO.setup(16, GPIO.IN, pull_up_down=GPIO.PUD_UP) # button #3

iStarted = 0
# status button 01: 0 = nothing started, 1=sondecfg0_0, 2=sondecfg0_1
iStatus_Button01 = 0

# status button 02: 0 = nothing started, 1=aprsmap started
iStatus_Button02 = 0

while True:
    Button01 = GPIO.input(21)
    Button02 = GPIO.input(20)
    Button03 = GPIO.input(16)

    if Button01 == False:
        if iStatus_Button01 == 0:
            print("starting 401.0 - 403.0 MHz")
            subprocess.call("/home/pi/dxlAPRS/aprs/strsonde_wo_srv_0.sh")
            time.sleep(1)
            iStatus_Button01 = 1
        elif iStatus_Button01 == 1:
            print("starting 403.0 - 405.0 MHz")
            subprocess.call("/home/pi/dxlAPRS/aprs/strsonde_wo_srv_1.sh")
            time.sleep(1)
            iStatus_Button01 = 2
        else:
            print("stopping decoding")
            subprocess.call("/home/pi/dxlAPRS/aprs/endsonde.sh")
            time.sleep(1)
            iStatus_Button01 = 0

    if Button02 == False:
        if iStatus_Button02 == 0:
            print("Reserve")
            # start application

            time.sleep(1)
            iStatus_Button02 = 1
        else:
            print("Reserve")
            # stop application

            time.sleep(1)
            iStatus_Button02 = 0

    # Button03 is to shutdown the raspberry
    if Button03 == False:
        print("shutting down...")
        subprocess.call("/home/pi/dxlAPRS/shutdown.sh")
        time.sleep(1)
        iStarted = 0

