#!/bin/bash

#   ***************************************************************** OE1FFS *************************************************************************
#   * Hi, hier starten wir alle Tools um dekodierte Daten auf APRS.FI zu sehen - dieses Script laeuft hier auf einem RASPBERRY PI 3 unter DEBIAN 8.x *
#   * Die Programme und Konfigfiles muessen unter /home/pi/sonde zu finden sein - wenn anders bitte entsprechend die Pfade aendern                   *
#   *********************************************************************************************************************** OE3OSB 2016-07-11 * V1.2 *

#------------------------------------------------------------------------------------------------------------------------------------------------------
# Als erstes beenden wir vorsorgend alle Programme die wir vielleicht schon gestartet haben (sonden tools)
#------------------------------------------------------------------------------------------------------------------------------------------------------
# 
#

killall -9 getalmd rtl_tcp sondeudp sdrtst sondemod udpgate4
sleep 3

#------------------------------------------------------------------------------------------------------------------------------------------------------
# Definieren wir das Sondenverzeichnis
#------------------------------------------------------------------------------------------------------------------------------------------------------

PATH=/home/pi/dxlAPRS/aprs:$PATH


#------------------------------------------------------------------------------------------------------------------------------------------------------
# Holen wir uns den aktuellen Almanach 
#------------------------------------------------------------------------------------------------------------------------------------------------------
xfce4-terminal --title GETALM --geometry 80x19+420+350 -e getalm &
sleep 3
xfce4-terminal --title GETALMD --geometry 80x19+420+350 -e getalmd &
sleep 3

#------------------------------------------------------------------------------------------------------------------------------------------------------
# Hier starten wir den SDR Stick und warten auf die Anweisungen vom "SONDEUDP" (Frequenz, ppm, ...)
#------------------------------------------------------------------------------------------------------------------------------------------------------
# Hier gebe ich dem Stick den Port und die IP <-a xxx.xxx.xxx.xxx> auf die er hoeren soll - Standard ist 127.0.0.1:1234
# wenn nur lokal alles laeuft ->>> lxterminal -e 'bash -c "echo 1:rtl_tcp - stick wakeup && rtl_tcp -p 18100"' &
#------------------------------------------------------------------------------------------------------------------------------------------------------
# Stick 1
xfce4-terminal --title RTL_TCP0 --geometry 100x15-10-10 -e 'bash -c "rtl_tcp -a 127.0.0.1 -d0 -p 18100"' &
sleep 3

# Stick 2
#xfce4-terminal --title RTL_TCP1 --geometry 100x15-10-10 -e 'bash -c "rtl_tcp -a 127.0.0.1 -d1 -p 18101"' &
#sleep 3


#------------------------------------------------------------------------------------------------------------------------------------------------------
# USER SPEZIFISCH - RUFZEICHEN - SSID
#------------------------------------------------------------------------------------------------------------------------------------------------------
# SONDEUDP - Sound rein -> dekodiertes UDP Paket raus - -u <ip:port> = IP und UDP Port vom SONDEMOD      -3    -6
#------------------------------------------------------------------------------------------------------------------------------------------------------
# Stick 1
xfce4-terminal --title SONDEUDP0 --geometry 100x20-10+40 -e 'bash -c "sondeudp -f 16000 -o /home/pi/dxlAPRS/aprs/lalala0 -I <CALL-12> -u 127.0.0.1:18000 -c 0 -v -N 172"' &
sleep 3

# Stick 2
#xfce4-terminal --title SONDEUDP1 --geometry 100x20-10+38 -e 'bash -c "sondeudp -f 16000 -o /home/pi/dxlAPRS/aprs/lalala1 -I <CALL-12> -u 127.0.0.1:18000 -c 0 -v"' &
#sleep 3


#------------------------------------------------------------------------------------------------------------------------------------------------------
# SDRTST - Hier senden wir die Infos an den Stick (sdrcfg.txt) und Samplerate (16000 = 16kHz) -t <ip:port> vom Stick 
# (das Soundfile mit "mknod lalala p" erstellen nicht vergessen)
#------------------------------------------------------------------------------------------------------------------------------------------------------
#
#------------------------------------------------------------------------------------------------------------------------------------------------------
# 20170615 - Offset eingebaut (-o -0,605) o -0,440 fuer die NooEleccom Sticks von Amazon - die haben einen TXCO
#
# Stick 1
xfce4-terminal --title SDRTST0 --geometry 80x20+420-10 -e 'bash -c "sdrtst -t 127.0.0.1:18100 -r 16000 -s /home/pi/dxlAPRS/aprs/lalala0 -Z 100 -c /home/pi/dxlAPRS/aprs/sdrcfg0_0.txt -v "'&
sleep 3

# Stick 2
#xfce4-terminal --title SDRTST1 --geometry 80x20+420-08 -e 'bash -c "sdrtst -t 127.0.0.1:18101 -r 16000 -s /home/pi/dxlAPRS/aprs/lalala1 -Z 100 -c /home/pi/dxlAPRS/aprs/sdrcfg1.txt -v "'&
#sleep 3


#------------------------------------------------------------------------------------------------------------------------------------------------------
# SONDEMOD - Der bekommt alle SONDEUDP Packete auf Port 18000 (-o) rein (der sammelt alle Daten) und stellt diese als 'axudp" zur Verfuegung.
#            (auch afskmodem moeglich mit udpflex wandelt in tcpkiss) -I ist DEINCALL-SSID | SSID Vorzugsweise 11-13)
#------------------------------------------------------------------------------------------------------------------------------------------------------

xfce4-terminal --title SONDEMOD -e 'bash -c "sondemod -o 18000 -I <CALL-12> -r 127.0.0.1:9001 -b 20 -B 6 -A 1500 -x /tmp/e.txt -T 360 -R 240 -d -p 2 -t /home/pi/dxlAPRS/aprs/sondecom.txt -v"'&
sleep 3

#--------------------------------------------------------------------------------------------------------------------------------------------------
# UDPBOX
#--------------------------------------------------------------------------------------------------------------------------------------------------
# verteilt die UDP Daten gleichzeitig auf mehrere Ports für mehrere Ausgänge z.B. APRS + Radiosondy + APRSMAP etc...
# -R receive Port   -r send Port
# -------------------------------------------------------------------------------------------------------------------------------------------------

xfce4-terminal  --title UDPBOX --geometry 80x10-10-10 -e 'bash -c "udpbox -R 127.0.0.1:9001 -r 127.0.0.1:9101 -r 127.0.0.1:9102 -r 127.0.0.1:9105 -v" ' &
sleep 3

#------------------------------------------------------------------------------------------------------------------------------------------------------
# UDPGATE4 - in aprs-is format wandeln, zugleich server zum Verteilen der Daten - oder an einen vorhandenen igate senden der axudp kann (-R <ip:port> ...), 
# oder an APRSMAP an einen "RF Port" --> M <ip:port> ..., -t=lokaler TCP port (14580) des igate fuer incomming connections, -p=dein aprs.fi passwort
# 
# entsprechende Zeile das # Zeichen entfernen und die anderen 2 mit # vorstellen! nur 1 Auswahl ist gültig!!!
#------------------------------------------------------------------------------------------------------------------------------------------------------
# Sondendaten to Radiosondy.info and forward to APRS Network Server (Port 14580)
# xfce4-terminal --title UDPGATE4 -e 'bash -c "udpgate4 -s <CALL-SSID> -R 0.0.0.0:0:9001 -n 10:/home/pi/dxlAPRS/aprs/netbeacon.txt -g radiosondy.info:14580 -p <APRS-ID> -t 14580 -w 14501 -v -D /home/pi/dxlAPRS/aprs/www/"'

# Sondendaten to Radiosondy.info only!!! NOT forwarding to APRS Network Server (Port 14590)
#xfce4-terminal --title UDPGATE4radiosondy -e 'bash -c "udpgate4 -s <CALL-SSID> -R 0.0.0.0:0:9101 -n 10:/home/pi/dxlAPRS/aprs/netbeacon.txt -g radiosondy.info:14590 -p <APRS-ID> -t 14590 -w 14501 -v -D /home/pi/dxlAPRS/aprs/www/"'

# Sondendaten zu APRS Network Server only!!!
#xfce4-terminal --title UDPGATE4aprs -e 'bash -c "udpgate4 -s <CALL-SSID> -R 0.0.0.0:0:9102 -n 10:/home/pi/dxlAPRS/aprs/netbeacon.txt -g austria.aprs2.net:14580 -p <APRS-ID> -t 14580 -w 14502 -v -D /home/pi/dxlAPRS/aprs/www/"'

# Sondendaten zu APRSMAP only!!!
xfce4-terminal --title UDPGATE4map -e 'bash -c "udpgate4 -s <CALL-SSID> -R 0.0.0.0:0:9105 -n 10:/home/pi/dxlAPRS/aprs/netbeacon.txt -M 127.0.0.1:9106 -w 14505 -v -D /home/pi/dxlAPRS/aprs/www/"'


#--- ENDE ---------------------------------------------------------------------------------------------------------------------------------------------------
